{
    "swagger": "2.0",
    "info": {
        "description": "devops server",
        "title": "Devops API",
        "contact": {},
        "version": "1.0"
    },
    "paths": {
        "/api/v1/devops-internal/controlplane/deployments/{deployment_id}/apply/complete": {
            "post": {
                "description": "callback when apply workflow completes",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "DeploymentController"
                ],
                "operationId": "DeploymentControllerOnApplyComplete",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "deployment id",
                        "name": "deployment_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request body",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/controlplane.OnApplyCompleteReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops-internal/controlplane/deployments/{deployment_id}/preview/complete": {
            "post": {
                "description": "callback when preview workflow completes",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "DeploymentController"
                ],
                "operationId": "DeploymentControllerOnPreviewComplete",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "deployment id",
                        "name": "deployment_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request body",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/controlplane.OnPreviewCompleteReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops-internal/github/pulls/sync": {
            "post": {
                "description": "sync all pull requests manually",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "GithubController"
                ],
                "operationId": "GithubControllerSyncPullRequests",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops-internal/github/repos/sync": {
            "post": {
                "description": "sync all repos manually",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "GithubController"
                ],
                "operationId": "GithubControllerSyncRepositories",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops-internal/itoken/.well-known/jwks.json": {
            "get": {
                "description": "get jwks in standard format for token verification",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "InternalTokenController"
                ],
                "operationId": "InternalTokenControllerGetWellKnownJWKS",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/itoken.JWKSet"
                        }
                    }
                }
            }
        },
        "/api/v1/devops-internal/release/releases/sync": {
            "post": {
                "description": "sync all releases manually",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ReleaseController"
                ],
                "operationId": "ReleaseControllerSyncReleaseManually",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops-internal/tenants": {
            "get": {
                "description": "list tenants internal",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "TenantService"
                ],
                "operationId": "ListTenantsInternal",
                "parameters": [
                    {
                        "type": "array",
                        "items": {
                            "enum": [
                                "internal",
                                "external"
                            ],
                            "type": "string"
                        },
                        "collectionFormat": "csv",
                        "name": "kind",
                        "in": "query"
                    },
                    {
                        "enum": [
                            "asc",
                            "desc"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "OrderTypeASC",
                            "OrderTypeDESC"
                        ],
                        "name": "order",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    },
                    {
                        "type": "array",
                        "items": {
                            "enum": [
                                "new_user",
                                "free_trial",
                                "poc",
                                "on_demand"
                            ],
                            "type": "string"
                        },
                        "collectionFormat": "csv",
                        "name": "plan",
                        "in": "query"
                    },
                    {
                        "type": "array",
                        "items": {
                            "enum": [
                                "APAC",
                                "EMEA",
                                "JAPAN",
                                "NA",
                                "UNKNOWN",
                                "RDG",
                                "TEST_INFRA",
                                "LATAM"
                            ],
                            "type": "string"
                        },
                        "collectionFormat": "csv",
                        "name": "region",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "search",
                        "in": "query"
                    },
                    {
                        "type": "array",
                        "items": {
                            "enum": [
                                "SKA",
                                "KA",
                                "SMB"
                            ],
                            "type": "string"
                        },
                        "collectionFormat": "csv",
                        "name": "segmentation",
                        "in": "query"
                    },
                    {
                        "enum": [
                            "created_at",
                            "timezone"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "SortByTypeCreatedAt",
                            "SortByTypeTimezone"
                        ],
                        "name": "sort_by",
                        "in": "query"
                    },
                    {
                        "type": "array",
                        "items": {
                            "enum": [
                                "pending",
                                "active",
                                "inactive",
                                "deleted",
                                "cleared"
                            ],
                            "type": "string"
                        },
                        "collectionFormat": "csv",
                        "name": "status",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/tenant.ListTenantResp"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops-internal/tenants/{tenant_id}": {
            "get": {
                "description": "get tenant internal",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "TenantService"
                ],
                "operationId": "GetTenantInternal",
                "parameters": [
                    {
                        "type": "string",
                        "description": "tenant_id",
                        "name": "tenant_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/tenant.GetTenantResp"
                        }
                    },
                    "500": {
                        "description": "Internal Server Error",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/accountusers/{user_id}": {
            "delete": {
                "description": "delete account user",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "TenantService"
                ],
                "operationId": "DeleteAccountUser",
                "parameters": [
                    {
                        "type": "string",
                        "description": "user_id",
                        "name": "user_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "DeleteAccountUserReq",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/tenant.DeleteAccountUserReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/tenant.CommonResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/application/applications": {
            "get": {
                "description": "list applications",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApplicationController"
                ],
                "operationId": "ApplicationControllerListApplication",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/application.ListApplicationResp"
                        }
                    }
                }
            },
            "post": {
                "description": "create a application",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApplicationController"
                ],
                "operationId": "ApplicationControllerCreateApplication",
                "parameters": [
                    {
                        "description": "request",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/application.CreateApplicationReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/application.CreateApplicationResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/application/applications/{name}": {
            "get": {
                "description": "get a application",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApplicationController"
                ],
                "operationId": "ApplicationControllerGetApplication",
                "parameters": [
                    {
                        "type": "string",
                        "description": "application name",
                        "name": "name",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/application.GetApplicationResp"
                        }
                    }
                }
            },
            "put": {
                "description": "update a application",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApplicationController"
                ],
                "operationId": "ApplicationControllerUpdateApplication",
                "parameters": [
                    {
                        "type": "string",
                        "description": "application name",
                        "name": "name",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/application.CreateApplicationReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            },
            "delete": {
                "description": "delete a application",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApplicationController"
                ],
                "operationId": "ApplicationControllerDeleteApplication",
                "parameters": [
                    {
                        "type": "string",
                        "description": "application name",
                        "name": "name",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/approval/approvals": {
            "post": {
                "description": "create a approval",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApprovalController"
                ],
                "operationId": "ApprovalControllerCreateApproval",
                "parameters": [
                    {
                        "description": "create approval request",
                        "name": "request",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/approval.CreateApprovalReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/approval.CreateApprovalResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/approval/approvals/{appr_id}": {
            "get": {
                "description": "get a approval",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApprovalController"
                ],
                "operationId": "ApprovalControllerGetApproval",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "approval id",
                        "name": "appr_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/approval.GetApprovalResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/approval/approvals/{appr_id}/admin_approve": {
            "post": {
                "description": "approve a approval by admin",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApprovalController"
                ],
                "operationId": "ApprovalControllerAdminApprove",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "approval id",
                        "name": "appr_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/approval/approvals/{appr_id}/approve": {
            "post": {
                "description": "approve a approval",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApprovalController"
                ],
                "operationId": "ApprovalControllerUserApprove",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "approval id",
                        "name": "appr_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/approval/approvals/{appr_id}/cancel": {
            "post": {
                "description": "cancel a approval",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApprovalController"
                ],
                "operationId": "ApprovalControllerCancelApproval",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "approval id",
                        "name": "appr_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/approval/approvals/{appr_id}/reject": {
            "post": {
                "description": "approve a approval",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "ApprovalController"
                ],
                "operationId": "ApprovalControllerUserReject",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "approval id",
                        "name": "appr_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/audit": {
            "get": {
                "description": "list audit logs",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "AuditController"
                ],
                "operationId": "AuditControllerListAuditLog",
                "parameters": [
                    {
                        "type": "string",
                        "name": "instance_id",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    },
                    {
                        "enum": [
                            "change",
                            "ctl",
                            "cluster_maintenance",
                            "operation",
                            "jump",
                            "cloud_config_change",
                            "cloud_config_default_config_change",
                            "k8s_upgrade_task",
                            "tenant",
                            "spu_sku",
                            "rbac_role",
                            "rbac_rolebinding",
                            "iam_role",
                            "iam_rolebinding",
                            "iam_policy",
                            "iam_policybinding",
                            "iam_apikey"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "AuditLogTypeChange",
                            "AuditLogTypeCtl",
                            "AuditLogTypeClusterMaintenance",
                            "AuditLogTypeOperation",
                            "AuditLogTypeJump",
                            "AuditLogTypeCloudConfigChange",
                            "AuditLogTypeCloudConfigDefaultConfigChange",
                            "AuditLogTypeK8sUpgradetask",
                            "AuditLogTypeTenant",
                            "AuditLogTypeSpuSku",
                            "AuditLogTypeRBACRole",
                            "AuditLogTypeRBACRoleBinding",
                            "AuditLogTypeIAMRole",
                            "AuditLogTypeIAMRoleBinding",
                            "AuditLogTypeIAMPolicy",
                            "AuditLogTypeIAMPolicyBinding",
                            "AuditLogTypeIAMAPIKey"
                        ],
                        "name": "type",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/audit.ListAuditLogResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/audit/changes": {
            "get": {
                "description": "list audit logs for changes",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "AuditController"
                ],
                "operationId": "AuditControllerListChangeAuditLog",
                "parameters": [
                    {
                        "type": "integer",
                        "name": "change_id",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/audit.ListChangeAuditLogResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/audit/cluster-maintenance": {
            "get": {
                "description": "list audit logs for cluster maintenance",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "AuditController"
                ],
                "operationId": "AuditControllerListClusterMaintenanceAuditLog",
                "parameters": [
                    {
                        "type": "integer",
                        "name": "maintenance_id",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/audit.ListClusterMaintenanceAuditLogResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/audit/ctl": {
            "get": {
                "description": "list audit logs for ctl",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "AuditController"
                ],
                "operationId": "AuditControllerListCtlAuditLog",
                "parameters": [
                    {
                        "type": "string",
                        "name": "cluster_id",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/audit.ListCtlAuditLogResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/audit/jumps": {
            "get": {
                "description": "list audit logs for jump authorizations",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "AuditController"
                ],
                "operationId": "AuditControllerListJumpAuditLog",
                "parameters": [
                    {
                        "type": "string",
                        "name": "authorization_id",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/audit.ListJumpAuditLogResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/audit/operations": {
            "get": {
                "description": "list audit logs for operation instances",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "AuditController"
                ],
                "operationId": "AuditControllerListOperationAuditLog",
                "parameters": [
                    {
                        "type": "integer",
                        "name": "instance_id",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/audit.ListOperationAuditLogResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/audit/types": {
            "get": {
                "description": "list audit log types",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "AuditController"
                ],
                "operationId": "AuditControllerListAuditLogTypes",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/audit.ListAuditLogTypesResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig-admin/parameter/attribute/clone": {
            "post": {
                "description": "clone paramter attributes from old version",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerCloneParameterAttribute",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CloneParamAttrReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig-admin/parameter/attribute/create": {
            "post": {
                "description": "create a paramter attribute",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerCreateParameterAttribute",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CreateParamAttrReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig-admin/parameter/attribute/{config_type}/{version}/{param_name}": {
            "put": {
                "description": "update a parameter attribute",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerUpdateParameterAttribute",
                "parameters": [
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "description": "cluster_type",
                        "name": "cluster_type",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "config_type",
                        "name": "config_type",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "version",
                        "name": "version",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "param_name",
                        "name": "param_name",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.UpdateParamAttrReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/changes/{change_id}": {
            "get": {
                "description": "get a config change of a cluster",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerGetConfigChange",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.GetConfigurationChangeResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/changes/{change_id}/apply": {
            "post": {
                "description": "aplly a config change",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerApplyConfigurationChange",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ApplyConfigurationChangeReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/changes/{change_id}/cancel": {
            "post": {
                "description": "cancel a config change",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerCancelConfigurationChange",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/cluster-components/search": {
            "get": {
                "description": "search cluster component versions",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerSearchClusterComponents",
                "parameters": [
                    {
                        "type": "string",
                        "name": "cluster_id",
                        "in": "query"
                    },
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "ClusterTypeUnknown",
                            "ClusterTypeDedicatedTiDB",
                            "ClusterTypeTiCDC",
                            "ClusterTypeChangefeed",
                            "ClusterTypeSharedPool",
                            "ClusterTypeLogicalCluster",
                            "ClusterTypeTiCDCNG",
                            "ClusterTypeChangefeedNG",
                            "ClusterTypeChangefeedEssential"
                        ],
                        "name": "cluster_type",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "component_name",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "component_version",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "image_tag",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "logical_region",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "maximum": 500,
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "region_mode",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "tenant_id",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.SearchClusterComponentsResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/cluster/changes": {
            "get": {
                "description": "list config changes",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListClusterConfigurationChanges",
                "parameters": [
                    {
                        "type": "string",
                        "name": "cluster_id",
                        "in": "query",
                        "required": true
                    },
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "ClusterTypeUnknown",
                            "ClusterTypeDedicatedTiDB",
                            "ClusterTypeTiCDC",
                            "ClusterTypeChangefeed",
                            "ClusterTypeSharedPool",
                            "ClusterTypeLogicalCluster",
                            "ClusterTypeTiCDCNG",
                            "ClusterTypeChangefeedNG",
                            "ClusterTypeChangefeedEssential"
                        ],
                        "name": "cluster_type",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "name": "created_at_end_unix_sec",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "created_at_start_unix_sec",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "have_modified_param_like",
                        "in": "query"
                    },
                    {
                        "type": "boolean",
                        "name": "id_only",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListConfigurationChangeResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            },
            "post": {
                "description": "change the configuration of a cluster",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerCreateClusterConfigurationChange",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CreateClusterConfigurationChangeReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CreateConfigurationChangeResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/cluster/changes/preview": {
            "post": {
                "description": "change the configuration of a cluster",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerPreviewClusterConfigurationChange",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.PreviewClusterConfigurationChangeReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.PreviewConfigurationChangeResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/cluster/config": {
            "get": {
                "description": "get the current configuration of a cluster",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerGetClusterConfiguration",
                "parameters": [
                    {
                        "type": "string",
                        "name": "cluster_id",
                        "in": "query",
                        "required": true
                    },
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "ClusterTypeUnknown",
                            "ClusterTypeDedicatedTiDB",
                            "ClusterTypeTiCDC",
                            "ClusterTypeChangefeed",
                            "ClusterTypeSharedPool",
                            "ClusterTypeLogicalCluster",
                            "ClusterTypeTiCDCNG",
                            "ClusterTypeChangefeedNG",
                            "ClusterTypeChangefeedEssential"
                        ],
                        "name": "cluster_type",
                        "in": "query",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.GetConfigurationResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/components": {
            "get": {
                "description": "list available components",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListComponents",
                "parameters": [
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "description": "cluster_type",
                        "name": "cluster_type",
                        "in": "query",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListComponentsResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/config-types/{cluster_type}": {
            "get": {
                "description": "list available config types",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListConfigTypes",
                "parameters": [
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "description": "cluster_type",
                        "name": "cluster_type",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListConfigTypesResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes": {
            "get": {
                "description": "list template changes",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListDefaultConfigurationChanges",
                "parameters": [
                    {
                        "enum": [
                            "version_release",
                            "template_default_case_binding",
                            "default_component_config"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "DefaultConfigurationChangeItemTypeVersionRelease",
                            "DefaultConfigurationChangeItemTypeTemplateDefaultCaseBinding",
                            "DefaultConfigurationChangeItemTypeDefaultComponentConfig"
                        ],
                        "name": "contain_item_type",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListDefaultConfigurationChangesResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}": {
            "get": {
                "description": "get a template change",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerGetDefaultConfigurationChange",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "boolean",
                        "name": "with_change_items",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.GetDefaultConfigurationChangeResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/close": {
            "post": {
                "description": "close a template change",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerCloseDefaultConfigurationChange",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CloseDefaultConfigurationChangeReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/items": {
            "get": {
                "description": "list change items",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListDefaultConfigurationChangeItems",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "data_is",
                        "in": "query"
                    },
                    {
                        "enum": [
                            "version_release",
                            "template_default_case_binding",
                            "default_component_config"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "DefaultConfigurationChangeItemTypeVersionRelease",
                            "DefaultConfigurationChangeItemTypeTemplateDefaultCaseBinding",
                            "DefaultConfigurationChangeItemTypeDefaultComponentConfig"
                        ],
                        "name": "type_is",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListDefaultConfigurationChangeItemsResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/items/batchUpdate": {
            "post": {
                "description": "batch update change items",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerBatchUpdateDefaultConfigurationChangeItems",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.BatchUpdateDefaultConfigurationChangeItemsReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/items/stat": {
            "get": {
                "description": "stat change items",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerStatDefaultConfigurationChangeItems",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "boolean",
                        "name": "config_types_of_template_default_case_binding",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.StatDefaultConfigurationChangeItemsResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/items/unreleased": {
            "get": {
                "description": "list unreleased change items",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListUnreleasedDefaultConfigurationChangeItems",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "environment_is",
                        "in": "query",
                        "required": true
                    },
                    {
                        "enum": [
                            "version_release",
                            "template_default_case_binding",
                            "default_component_config"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "DefaultConfigurationChangeItemTypeVersionRelease",
                            "DefaultConfigurationChangeItemTypeTemplateDefaultCaseBinding",
                            "DefaultConfigurationChangeItemTypeDefaultComponentConfig"
                        ],
                        "name": "type_is",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListUnreleasedDefaultConfigurationChangeItemsResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/releases": {
            "get": {
                "description": "list change releases",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListDefaultConfigurationChangeReleases",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "environment_is",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListDefaultConfigurationChangeReleasesResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            },
            "post": {
                "description": "release a change to a environment",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerCreateDefaultConfigurationChangeRelease",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CreateDefaultConfigurationChangeReleaseReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/releases/rollback": {
            "post": {
                "description": "rollback a change to a environment",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerRollbackDefaultConfigurationChangeRelease",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.RollbackDefaultConfigurationChangeReleaseReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/releases/{release_id}": {
            "get": {
                "description": "list change releases",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerGetDefaultConfigurationChangeRelease",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "release id",
                        "name": "release_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "boolean",
                        "name": "with_released_items",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.GetDefaultConfigurationChangeRelease"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/releases/{release_id}/cancel": {
            "post": {
                "description": "cancel a release",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerCancelDefaultConfigurationChangeRelease",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "release id",
                        "name": "release_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/changes/{change_id}/releases/{release_id}/items": {
            "get": {
                "description": "list change item releases",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListDefaultConfigurationChangeItemRelease",
                "parameters": [
                    {
                        "type": "string",
                        "description": "change id",
                        "name": "change_id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "type": "string",
                        "description": "release id",
                        "name": "release_id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListDefaultConfigurationChangeItemReleaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/components": {
            "patch": {
                "description": "update default components",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerUpdateDefaultComponents",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/components/change": {
            "post": {
                "description": "create default components",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerChangeDefaultComponents",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ChangeDefaultComponentsReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CreateDefaultConfigurationChangeResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/template-bindings": {
            "get": {
                "description": "list template default cases",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListTemplateDefaultCaseBindings",
                "parameters": [
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "ClusterTypeUnknown",
                            "ClusterTypeDedicatedTiDB",
                            "ClusterTypeTiCDC",
                            "ClusterTypeChangefeed",
                            "ClusterTypeSharedPool",
                            "ClusterTypeLogicalCluster",
                            "ClusterTypeTiCDCNG",
                            "ClusterTypeChangefeedNG",
                            "ClusterTypeChangefeedEssential"
                        ],
                        "name": "cluster_type",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "config_type_is",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "default_for_cloud_provider",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "default_for_instance_type",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "default_for_tenant_id",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "default_for_version",
                        "in": "query"
                    },
                    {
                        "type": "boolean",
                        "name": "exact_match",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "page",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "per_page",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListTemplateDefaultCaseBindingsResp"
                        }
                    }
                }
            },
            "patch": {
                "description": "update template default cases",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerUpdateTemplateDefaultCaseBindings",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.UpdateTemplateDefaultCaseBindingsReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/template-bindings/change": {
            "post": {
                "description": "create a template change",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerChangeTemplateDefaultCaseBindings",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ChangeTemplateDefaultCaseBindingsReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.CreateDefaultConfigurationChangeResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/template-bindings/delete-by-op": {
            "post": {
                "description": "delete a template change",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerDeleteTemplateDefaultCaseBindingByOp",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.DeleteTemplateDefaultCaseBindingByOpReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.DeleteTemplateDefaultCaseBindingResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/template-bindings/update-by-op": {
            "post": {
                "description": "create a template change",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerUpdateTemplateDefaultCaseBindingByOp",
                "parameters": [
                    {
                        "description": "request param",
                        "name": "req",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.UpdateTemplateDefaultCaseBindingByOpReq"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.UpdateTemplateDefaultCaseBindingResp"
                        }
                    },
                    "default": {
                        "description": "",
                        "schema": {
                            "$ref": "#/definitions/api.BaseResp"
                        }
                    }
                }
            }
        },
        "/api/v1/devops/cloudconfig/default-config/versions/defaultrules": {
            "get": {
                "description": "List rules for choose default version",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "CloudConfigController"
                ],
                "operationId": "CloudConfigControllerListDefaultVersionRules",
                "parameters": [
                    {
                        "enum": [
                            "",
                            "DEDICATED_TIDB",
                            "TICDC",
                            "CHANGEFEED",
                            "SHARED_POOL",
                            "LOGICAL_CLUSTER",
                            "TICDC_NG",
                            "CHANGEFEED_NG",
                            "CHANGEFEED_ESSENTIAL"
                        ],
                        "type": "string",
                        "x-enum-varnames": [
                            "ClusterTypeUnknown",
                            "ClusterTypeDedicatedTiDB",
                            "ClusterTypeTiCDC",
                            "ClusterTypeChangefeed",
                            "ClusterTypeSharedPool",
                            "ClusterTypeLogicalCluster",
                            "ClusterTypeTiCDCNG",
                            "ClusterTypeChangefeedNG",
                            "ClusterTypeChangefeedEssential"
                        ],
                        "name": "cluster_type",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "component",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/cloudconfig.ListDefaultVersionRulesResp"
                        }
[...]
